﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;

namespace GridViewPasswordBox
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class GridViewPasswordColumn : GridViewBoundColumnBase
    {
        public GridViewPasswordColumn()
        {
            EditTriggers = GridViewEditTriggers.CellClick;
        }

        public override FrameworkElement CreateCellElement(GridViewCell cell, object dataItem)
        {
            return new TextBlock { Text = "**********" };
        }

        public override FrameworkElement CreateCellEditElement(GridViewCell cell, object dataItem)
        {
            var picker = new RadPasswordBox();
            return picker;
        }

        public override object GetNewValueFromEditor(object editor)
        {
            RadPasswordBox passwordBox = editor as RadPasswordBox;

            var user = passwordBox.DataContext as User;
            var password = passwordBox.Password;

            user.PasswordText = password;
            return password;
        }
    }
}
